/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.services.nset.commons;

import java.io.IOException;
import java.util.Locale;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;
import cdac.medinfo.sdk.dcm30_04.enums.EnumCommandField;
import cdac.medinfo.sdk.dcm30_04.exceptions.MandatoryMissingException;
import cdac.medinfo.sdk.dcm30_04.services.dicomnetcommons.ICommandElement;
import cdac.medinfo.sdk.dcm30_04.services.dicomnetcommons.InvalidCommandSetException;
import cdac.medinfo.sdk.dcm30_04.services.dicomnetcommons.InvalidDICOMMessageException;
import cdac.medinfo.sdk.dcm30_04.services.dimsecommons.CommandElement;
import cdac.medinfo.sdk.dcm30_04.services.dimsecommons.DIMSERequest;
import cdac.medinfo.sdk.dcm30_04.services.dimsecommons.DicomMessage;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;
import cdac.medinfo.sdk.dcm30_04.utils.ResourceBundleWrapper;

/**
 * This class defines the required fields to create request to perform N-Set Service.
 * It provides the required methods for all mandatory and optional fields of N-Set Request.  
 */
public class NSetRQ extends DIMSERequest
{
	/**
	 * Instantiates a new N-Set RQ. Creates default Dicom Message for N-Set RQ.
	 */
	public NSetRQ()
	{
	}

	/**
	 * Instantiates a new N-Set RQ when Dicom Message is given by user.
	 * Retrieves Command Set and Data Set from the DicomMessage and sets in N-Set Request.
	 * @param objDicomMessage instance of DicomMessage from which N-Set request is initialized.
	 * @throws IOException Signals that an I/O exception has occurred.
	 */
	public NSetRQ(DicomMessage objDicomMessage) throws IOException
	{
		objICommandSet = objDicomMessage.getCommandSet();
		objIDataSet = objDicomMessage.getDataSet();
	}
	
	/**
	 * Sets Requested SOP Class UID . 
	 * SOP Class UID associated with the operation.
	 * @param strRequestedSOPClassUID value of Requested SOP Class UID.
	 */
	public void setRequestedSOPClassUID(String strRequestedSOPClassUID)
	{
		ICommandElement objICommandElement = null;
		objICommandElement = new CommandElement(0x0000, 0x0003,strRequestedSOPClassUID);
		objICommandSet.addCommandElement(objICommandElement);
	}

	/**
	 * Retrieves Requested SOP Class UID . 
	 * SOP Class UID associated with the operation.
	 * @return String - value of Requested SOP Class UID .
	 */
	public String getRequestedSOPClassUID()
	{
		Object objValue = getValue(0x0000,0x0003);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	
	/**
	 * Sets the UID of the SOP Instance to be retrieved.
	 * @param strRequestedSOPInstanceUID String value of Requested SOP Instance UID.
	 */
	public void setRequestedSOPInstanceUID(String strRequestedSOPInstanceUID)
	{
		ICommandElement objICommandElement = null;
		objICommandElement = new CommandElement(0x0000, 0x1001,strRequestedSOPInstanceUID);
		objICommandSet.addCommandElement(objICommandElement);
	}

	/**
	 * Retrieves the UID of the SOP Instance to be retrieved.
	 * @return String - value of Requested SOP Instance UID.
	 */
	public String getRequestedSOPInstanceUID()
	{
		Object objValue = getValue(0x0000,0x1001);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	
	/**
	 * This method makes N-Set RQ's according to the given DataSet Collection.
	 * @param strSOPClassUID value of SOP Class UID.
	 * @param strReqSOPInstanceUID value of Requested SOP Instance UID.
	 * @param objIDataSet object of DataSet to be set in N-Set RQ.
	 * @return NSetRQ instance of N-Set RQ
	 */
	public static NSetRQ getDefaultRQ(String strSOPClassUID,String strReqSOPInstanceUID,IDataSet objIDataSet)
	{
		NSetRQ objNSetRQ = new NSetRQ();
		objNSetRQ.setRequestedSOPClassUID(strSOPClassUID);
		objNSetRQ.setRequestedSOPInstanceUID(strReqSOPInstanceUID);
		objNSetRQ.setCommandField(EnumCommandField.N_SET_RQ);
		if(null != objIDataSet && !objIDataSet.isEmpty())
			objNSetRQ.setCommandDataSetType(DicomConstants.DCM_DATASET_PRESENT);
		else
			objNSetRQ.setCommandDataSetType(DicomConstants.DCM_DATASET_NOT_PRESENT);
		objNSetRQ.setMessageID(shMsgID++);
		objNSetRQ.setDataSet(objIDataSet);
		objNSetRQ.setCommandGroupLength(objNSetRQ.getCommandSet().getCommandSetLength());

		//Validating RQ
		objNSetRQ.validate();
		return objNSetRQ;
	}
	
	/**
	 * Validates the request for their mandatory attributes only.
	 * @return true, if validation is successful.
	 * @throws InvalidDICOMMessageException If validation of mandatory fields fails.
	 */
	public boolean validate() throws InvalidDICOMMessageException
	{
		super.validate();
		try
		{	
			//Checks for service type.
			if(getCommandType() != EnumCommandField.N_SET_RQ)
				throw new InvalidDICOMMessageException(ResourceBundleWrapper.getValue("exceptions","RQNotMatched",new Locale(DicomConfig.createInstance().getLocale())) + getCommandType().name());
			
			if(!objICommandSet.isPresent(0x0000,0x0003))			// Requested SOP Class UID
				throw new MandatoryMissingException("0000,0003");
			else
			{
				if(objICommandSet.getValue(0x0000,0x0003) == null)
					throw new InvalidDICOMMessageException(ResourceBundleWrapper.getValue("exceptions", "NullValue",new Locale(DicomConfig.createInstance().getLocale())) + 0x0000 + "," + 0x0003);
			}
			
			if(!objICommandSet.isPresent(0x0000,0x1001))		// Requested SOP Instance UID
				throw new MandatoryMissingException("0000,1001");
			else
			{
				if(objICommandSet.getValue(0x0000,0x1001) == null)
					throw new InvalidDICOMMessageException(ResourceBundleWrapper.getValue("exceptions", "NullValue",new Locale(DicomConfig.createInstance().getLocale())) + 0x0000 + "," + 0x1001);
			}
			
			// Modification List as Data Set
			if(objIDataSet == null || objIDataSet.isEmpty())
			{
				if(DicomConfig.createInstance().isLoggingOn())
					DicomLogger.getLogger().log(ResourceBundleWrapper.getValue("exceptions", "EmptyDataSet", new Locale(DicomConfig.createInstance().getLocale())));
				
				throw new InvalidDICOMMessageException(ResourceBundleWrapper.getValue("exceptions", "EmptyDataSet",new Locale(DicomConfig.createInstance().getLocale())));
			}
		}
		catch(MandatoryMissingException mme)
		{
			InvalidCommandSetException objCommandSetException = new InvalidCommandSetException(mme);
			if(DicomConfig.createInstance().isLoggingOn())
				DicomLogger.getLogger().log(mme.getMessage());

			throw new InvalidDICOMMessageException(this.getClass().getSimpleName(),objCommandSetException);
		}	
		return true;
	}
}
